
%Output are only the critical values for the main approach for both choices
%of Bhat: Bhat = Identity matrix or Bhat = inv(Omega); the cv for the
%conservative approach are computed but not taken to the main code;
function [cvmom_O,cvmom_I] = cv_mom(T, phihat, lambdahat, kappaT, alpha, cv_fix, cvmom1, cvmom2, stepsize, Z3)
  
angle = [-pi/2 : stepsize: pi/2]; %(preferred stepsize 0.05)
phihat2 = phihat(2,1);
phihat3 = phihat(3,1);


for gg = 1:size(angle,2)
    
    q1 = cos(angle(1,gg));
    q2 = sin(angle(1,gg));
    
     if abs(angle(1,gg)) ~= pi/2
         Sigma = [q1 0 0 ; 0 q1 q2]*lambdahat*[q1 0 0 ; 0 q1 q2]';
         D_2 = diag(diag(Sigma(2:end,2:end)));
     elseif abs(angle(1,gg)) == pi/2
         Sigma = [0 q1 q2]*lambdahat*[0 q1 q2]';
         D_2 = diag(diag(Sigma));
     end
     
    csi = (sqrt(T))*diag(diag(D_2).^(-1/2))*(phihat2*q1 + phihat3*q2);%slackness of the second inequality condition
    
      
    if abs(angle(1,gg)) ~= pi/2 && csi < kappaT %second inequality is binding
        
         cvmom_Ofix(1,gg) =  cv_fix; %conservative approach: chi-squared(1) + squared truncated normal;
        
         
         D = diag(diag(Sigma)); 
         Omega = diag(diag(D).^(-1/2))*Sigma*diag(diag(D).^(-1/2));
         L = chol(lambdahat, 'lower');
             
             WO = inv(Omega);     
             WI = eye(size(Omega,2));
           
            for ss = 1:size(Z3,2)
         
                A = diag(diag(D).^(-1/2))*[q1 0 0 ; 0 q1 q2]*L*Z3(:,ss); % first term in the minimization problem
        
                    if  A(1,1)*WO(2,1)/WO(2,2) + A(2,1) >= 0
                        vO = A(1,1)*WO(2,1)/WO(2,2) + A(2,1);  
                    else
                        vO = 0;
                    end
                GbarO(1,ss) = [A-[0;vO]]'*WO*[A-[0;vO]];
                
                   if  A(1,1)*WI(2,1)/WI(2,2) + A(2,1) >= 0
                        vI = A(1,1)*WI(2,1)/WI(2,2) + A(2,1);  
                    else
                        vI = 0;
                    end
                GbarI(1,ss) = [A-[0;vI]]'*WI*[A-[0;vI]];
             end %end loop over random draws of Z3
             
         
         cvmom_O(1,gg)= prctile(GbarO,(1-alpha)*100); %main approach for moment inequality selection when Bhat = Omegainv
         cvmom_I(1,gg)= prctile(GbarI,(1-alpha)*100); %main approach for moment inequality selection when Bhat = I
        
    elseif abs(angle(1,gg))== pi/2 && csi < kappaT % binding inequality
   
         cvmom_Ofix(1,gg) = cvmom2; %conservative approach: squared truncated normal
  
         
        cvmom_O(1,gg) = cvmom2; %main approach: the solution to the minimization problem is same as quantile of square of truncated standard normal  
        cvmom_I(1,gg) = cvmom2;
        
    elseif  abs(angle(1,gg))~= pi/2 && csi >= kappaT %non-binding inequality
        
        cvmom_Ofix(1,gg) = cvmom1;%conservative approach: chi-squared(1)
             
        cvmom_O(1,gg) = cvmom1; %main approach: chi-squared(1)
        cvmom_I(1,gg) = cvmom1;
        
    elseif abs(angle(1,gg)) == pi/2 && csi >= kappaT %non-binding inequality   
       
        cvmom_Ofix(1,gg) = 0; 
           
        cvmom_O(1,gg) = 0; 
        cvmom_I(1,gg) = 0;
 
    end
   
    clear Omega
end  
   


