function [GthetaO,GthetaI] = f_Gtheta(theta, q1, q2, phihat, lambdahat, T)


if abs(q1) <=0.000000001 %to avoid singularity of (Sq*lambdahat*Sq')
    Sq = [ 0 q1 q2]; %matrix Stilda_q on page 10 NBER wp when q1 is zero; 
    Sigma = [0 q1 q2]*lambdahat*[ 0 q1 q2]';     
    
    Bhat = 1; %in case of rank reduction the matrix Bhat is just the scalar 1
    
    if Sq*phihat>=0
    mu_hat = Sq*phihat;
    else 
    mu_hat = 0;
    end
    
    Gtheta = T*(1/Sigma)*(Sq*phihat-mu_hat)^2;%objective function
    
    if theta ~= 0
        Gtheta = Gtheta + T;
    end
    
    GthetaO = Gtheta;
    GthetaI = Gtheta;
else
    Sq = [ q1 0 0 ;0 q1 q2]; %matrix Stilda_q on page 10 NBER wp;
    Sigma = [ q1 0 0 ;0 q1 q2]*lambdahat*[ q1 0 0 ;0 q1 q2]';    
    D = diag(diag(Sigma));   
    Omega = diag(diag(D).^(-1/2))*Sigma*diag(diag(D).^(-1/2));
    
    
        BhatO = inv(Omega);
        WO =  inv(Sigma); %weighting matrix: D^(-1/2) * Bhat * D^(-1/2) = Sigma 
    
        BhatI = eye(size(D));
        WI = inv(D);  %weighting matrix: D^(-1/2) * I * D^(-1/2) = D^(-1)
    
    SS = Sq*phihat;
    
     min_GmuO =(SS(1,1)-theta)* WO(2,1)/ WO(2,2) + (SS(2,1)); % mu that minimizes Gtheta
     min_GmuI =(SS(1,1)-theta)* WI(2,1)/ WI(2,2) + (SS(2,1)); % mu that minimizes Gtheta
     % minimize only wrt mu
     if  min_GmuO >= 0
         mu_hatO = min_GmuO;
     elseif  min_GmuO < 0
         mu_hatO = 0;
     end
     GthetaO = T*(Sq*phihat-[theta; mu_hatO])'*(D^(-1/2))'*BhatO*(D^(-1/2))*(Sq*phihat-[theta; mu_hatO]);
     
     % minimize only wrt mu
     if  min_GmuI >= 0
         mu_hatI = min_GmuI;
     elseif  min_GmuI < 0
         mu_hatI = 0;
     end
     GthetaI = T*(Sq*phihat-[theta; mu_hatI])'*(D^(-1/2))'*BhatI*(D^(-1/2))*(Sq*phihat-[theta; mu_hatI]);
end